// Generated by CoffeeScript 1.12.7
var Rollbar, RollbarStream, _, stream, util,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

stream = require('stream');

util = require('util');

Rollbar = require('rollbar');

_ = require('underscore');

RollbarStream = (function(superClass) {
  extend(RollbarStream, superClass);

  function RollbarStream(opts) {
    var ref, streamWritableOpts;
    if (opts == null) {
      opts = {};
    }
    streamWritableOpts = _({}).extend(opts, {
      objectMode: true
    });
    if (streamWritableOpts.highwaterMark == null) {
      streamWritableOpts.highwaterMark = 100;
    }
    RollbarStream.__super__.constructor.call(this, streamWritableOpts);
    this.client = (ref = opts.client) != null ? ref : (function() {
      var config;
      config = _(opts).chain().omit('token').defaults({
        accessToken: opts.token,
        branch: 'master',
        root: process.cwd(),
        host: process.env.DYNO
      }).value();
      return new Rollbar(config);
    })();
  }

  RollbarStream.prototype._write = function(obj, encoding, cb) {
    var customData, err, rebuiltErr, req;
    customData = _(obj).omit('msg', 'err', 'req');
    if (obj.msg != null) {
      customData.title = obj.msg;
    }
    if (obj.err != null) {
      rebuiltErr = RollbarStream.rebuildErrorForReporting(obj.err);
      err = new Error(rebuiltErr.message);
      err.stack = rebuiltErr.stack;
      customData.error = _.omit(obj.err, 'message', 'stack');
    } else {
      err = obj.msg;
    }
    if (obj.req != null) {
      req = _.clone(obj.req);
      if (req.socket == null) {
        req.socket = {};
      }
      if (req.connection == null) {
        req.connection = {};
      }
    } else {
      req = null;
    }
    return this.client.error(err, req, customData, function(e2) {
      if (e2 != null) {
        process.stderr.write(util.format.call(util, 'Error logging to Rollbar', e2.stack || e2) + "\n");
      }
      if (cb != null) {
        return cb(e2);
      }
    });
  };

  RollbarStream.FIBER_ROOT_CAUSE_SEPARATOR = /^\s{4}- - - - -\n/gm;

  RollbarStream.rebuildErrorForReporting = function(inErr) {
    var err, firstLine, remainder, stackLines;
    err = Object.create(inErr);
    if (this.FIBER_ROOT_CAUSE_SEPARATOR.test(err.stack)) {
      firstLine = err.stack.split('\n', 1)[0] + '\n';
      remainder = err.stack.replace(firstLine, '');
      if (!/\n$/.test(remainder)) {
        remainder += '\n';
      }
      stackLines = remainder.split(this.FIBER_ROOT_CAUSE_SEPARATOR);
      stackLines.reverse();
      err.stack = (firstLine + stackLines.join('    at which_caused_the_waiting_fiber_to_throw:0:0\n')).trim();
    }
    return err;
  };

  return RollbarStream;

})(stream.Writable);

module.exports = RollbarStream;
